/* Copyright 2010 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: AppState.h 230 2010-12-18 14:22:31Z tonic $
 * $Revision: 230 $
 */

#ifndef APPSTATE_H_INCL
#define APPSTATE_H_INCL


enum APPSTATE_ENUM
{
    APPSTATE_DEFAULT_FPS = 60
};


class AppState
{
public:

    AppState() : mFPS(APPSTATE_DEFAULT_FPS),
                 mGameLogicTime(0), mStateTime(0), mPaused(false) {}
    virtual ~AppState() {}

    virtual bool init() { return true; }
    virtual void deinit() {}

    I32 getUpdateFPS() { return mFPS; }

    virtual bool update(I32 deltaTime);
    virtual void render(irr::IrrlichtDevice *device) = 0;

    virtual void onActivate() { mGameLogicTime = mStateTime = 0; mPaused = false; }
    virtual void onDeactivate() {}

    virtual bool onKeyDown(const irr::SEvent::SKeyInput &event) { return false; }
    virtual bool onKeyUp(const irr::SEvent::SKeyInput &event) { return false; }
    virtual bool onMouseDown(const irr::SEvent::SMouseInput &event) { return false; }
    virtual bool onMouseUp(const irr::SEvent::SMouseInput &event) { return false; }
    virtual bool onMouseMotion(const irr::SEvent::SMouseInput &event) { return false; }
    virtual bool onMouseWheel(const irr::SEvent::SMouseInput &event) { return false; }

protected:

    I32 mFPS;
    I32 mGameLogicTime, mStateTime;
    bool mPaused;
};


#endif // !APPSTATE_H_INCL
