/* Turska Framework/UI library (Turs2)
 * Copyright 2003-2009 Jetro Lauha
 * All rights reserved.
 * Web: http://iki.fi/jetro/turska/
 *
 * $Id: errormsg.c 227 2010-12-18 14:07:49Z tonic $
 * $Revision: 227 $
 */

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

#include "errormsg.h"


static void sShowError(char *title, char *msg, va_list ap)
{
#ifdef WIN32
#define BUFLEN 2048
    char s[BUFLEN] = { 0 };
#if _MSC_VER >= 1300
    _vsnprintf_s(s, BUFLEN, _TRUNCATE, msg, ap);
#else
    _vsnprintf(s, BUFLEN - 1, msg, ap);
#endif
    MessageBoxA(0, s, title, MB_OK | MB_APPLMODAL | MB_ICONEXCLAMATION);
#undef BUFLEN
#else
    fflush(stderr);
    fflush(stdout);
    fprintf(stderr, "\n%s: ", title);
    vfprintf(stderr, msg, ap);
    fprintf(stderr, "\n");
    fflush(stderr);
#endif
}


void gErrorMessage(char *title, char *msg, ...)
{
    va_list ap;
    va_start(ap, msg);
    sShowError(title, msg, ap);
}
