/* Copyright 2010 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: main.cpp 242 2010-12-20 02:01:25Z tonic $
 * $Revision: 242 $
 */

#ifdef _MSC_VER
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif // _MSC_VER

#include <assert.h>

#include "main.h"


bool gAlive = true;

int gVersion = 0x010000;
char *gVersionString = "v 1.0.0";


#ifdef _MSC_VER
INT WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR strCmdLine, INT)
#else
int main(int argc, char* argv[])
#endif
{
    //video::E_DRIVER_TYPE driverType = video::EDT_OPENGL;
    video::E_DRIVER_TYPE driverType = video::EDT_DIRECT3D9;

    IrrlichtDevice *device =
        createDevice(driverType, core::dimension2d<u32>(WIDTH, HEIGHT), 32, false, true, true);

    if (device == 0)
    {
        gErrorMessage("Error", "Cannot initialize engine with given video driver & parameters.");
        return 1; // could not create selected driver.
    }

    device->setWindowCaption(L"Loading...");

    #ifndef _DEBUG
    device->getFileSystem()->addZipFileArchive("gamedata.zip", false, false);
    #endif

    video::IVideoDriver *driver = device->getVideoDriver();
    driver->setTextureCreationFlag(video::ETCF_OPTIMIZED_FOR_QUALITY, true);

    App *app = new App(device);
    assert(app);
    if (app != NULL)
    {
        bool result = app->init(device);
        if (result)
        {
            device->setEventReceiver(app);

            MainState *ms = new MainState;
            if (ms && ms->init())
            {
                app->setAppStateHandler(ms);
                device->setWindowCaption(app->getWindowCaption());
                app->run();
            }
            else
                gErrorMessage("Error", "Couldn't initialize MainState.");
            ms->deinit();
            delete ms;
        }
        delete app;
    }

    device->drop();

    return 0;
}
